searchData={"items":[{"type":"module","title":"Thumbnex","doc":"Create thumbnails from images and videos.","ref":"Thumbnex.html"},{"type":"function","title":"Thumbnex.animated_gif_thumbnail/3","doc":"Create an animated GIF preview.\n\nOptions:\n\n* `:width` - Width of the thumbnail. Defaults to input width.\n* `:height` - Height of the thumbnail. Defaults to input height.\n* `:max_width` - Maximum width of the thumbnail.\n* `:max_height` - Maximum height of the thumbnail.\n* `:frame_count` - Number of frames to output. Default 4.\n* `:fps` - Frames per second of output GIF. Default 1.\n* `:optimize` - Add mogrify options to reduce output size. Default true.","ref":"Thumbnex.html#animated_gif_thumbnail/3"},{"type":"function","title":"Thumbnex.create_thumbnail/3","doc":"Create a thumbnail image.\n\nImage format is inferred from output path file extension.\nTo override, pass the `:format` option.\n\nReturn `:ok` if everything goes well or `{:error, error_output}`\n\nOptions:\n\n* `:width` - Width of the thumbnail. Defaults to input width.\n* `:height` - Height of the thumbnail. Defaults to input height.\n* `:max_width` - Maximum width of the thumbnail.\n* `:max_height` - Maximum height of the thumbnail.\n* `:format` - Output format for the thumbnail. Defaults to `output_path` extension, or `\"png\"` if indeterminate.\n* `:time_offset` - Timestamp in seconds at which to take screenshot, for videos and GIFs.\n  By default picks a time near the beginning, based on video duration.","ref":"Thumbnex.html#create_thumbnail/3"},{"type":"module","title":"Thumbnex.Animations","doc":"","ref":"Thumbnex.Animations.html"},{"type":"function","title":"Thumbnex.Animations.duration/1","doc":"","ref":"Thumbnex.Animations.html#duration/1"},{"type":"module","title":"Thumbnex.ExtractFrame","doc":"","ref":"Thumbnex.ExtractFrame.html"},{"type":"function","title":"Thumbnex.ExtractFrame.multiple_frames/4","doc":"Extract multiple frames from the input file.\nSpecify the number of frames, and the frames per second, to output.\n\nReturns a tuple with :ok and the path of the output file (a single file containing multiple frames) or :error and the cmd output and exit status\n\nOptions:\n\n* `:output_path` - Where to store the resulting file. Defaults to temporary file.\n* `:output_ext` - File extension for output. Ignored if `:output_path` is set. Defaults to `\".gif\"`.","ref":"Thumbnex.ExtractFrame.html#multiple_frames/4"},{"type":"function","title":"Thumbnex.ExtractFrame.single_frame/3","doc":"Extract a single frame from the input file.\n\nSpecify the time offset in seconds (0 for still images).\n\nReturns a tuple with :ok and the path of the single frame image file or :error and cmd output and exit status\n\nOptions:\n\n* `:output_path` - Where to store the resulting file. Defaults to temporary file.\n* `:output_ext` - File extension for output. Ignored if `:output_path` is set. Defaults to `\".png\"`.","ref":"Thumbnex.ExtractFrame.html#single_frame/3"},{"type":"module","title":"Thumbnex.Gifs","doc":"","ref":"Thumbnex.Gifs.html"},{"type":"function","title":"Thumbnex.Gifs.duration/1","doc":"Return the GIF duration in seconds.","ref":"Thumbnex.Gifs.html#duration/1"},{"type":"function","title":"Thumbnex.Gifs.optimize_mogrify_image/1","doc":"","ref":"Thumbnex.Gifs.html#optimize_mogrify_image/1"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"0.5.0 (2024-01-24) - Changelog","doc":"* Breaking changes\n  * `Thumbnex.create_thumbnail/3` can now return `{:error, error_output}` instead of crashing. Still returns `:ok` on success. ([#15](https://github.com/talklittle/thumbnex/pull/15))\n  * `Thumbnex.animated_gif_thumbnail/3` can return `{:error, {cmd_output, error_status}}` instead of crashing. Still returns `:ok` on success. ([#15](https://github.com/talklittle/thumbnex/pull/15))\n  * `Thumbnex.Animations.duration/1` now returns `{:ok, duration}` or `{:ok, :no_duration}` or `{:error, reason}`. ([#15](https://github.com/talklittle/thumbnex/pull/15))\n  * `Thumbnex.ExtractFrame.single_frame/3` now returns `{:ok, path}` or `{:error, {cmd_output, error_status}}`. ([#15](https://github.com/talklittle/thumbnex/pull/15))\n  * `Thumbnex.ExtractFrame.multiple_frames/4` now returns `{:ok, path}` or `{:error, {cmd_output, error_status}}`. ([#15](https://github.com/talklittle/thumbnex/pull/15))\n  * Require Elixir 1.12.\n\n* Enhancements\n  * Bump dependency versions. ([#16](https://github.com/talklittle/thumbnex/pull/16))\n\n* Bugfixes\n  * Fixed warnings on Elixir 1.16. ([#17](https://github.com/talklittle/thumbnex/pull/17))","ref":"changelog.html#0-5-0-2024-01-24"},{"type":"extras","title":"0.4.0 (2021-11-16) - Changelog","doc":"* Bump ffmpex dependency to 0.9.0.\n* Require Elixir 1.9.\n\n#","ref":"changelog.html#0-4-0-2021-11-16"},{"type":"extras","title":"0.3.6 (2021-11-10) - Changelog","doc":"* Bump ffmpex dependency to 0.8.0.\n\n#","ref":"changelog.html#0-3-6-2021-11-10"},{"type":"extras","title":"0.3.5 (2021-07-03) - Changelog","doc":"* Bump mogrify dependency to 0.9.0.\n\n#","ref":"changelog.html#0-3-5-2021-07-03"},{"type":"extras","title":"0.3.4 (2021-05-05) - Changelog","doc":"* Bump dependency versions.\n\n#","ref":"changelog.html#0-3-4-2021-05-05"},{"type":"extras","title":"0.3.3 (2020-07-09) - Changelog","doc":"* Bump dependency versions.\n\n#","ref":"changelog.html#0-3-3-2020-07-09"},{"type":"extras","title":"0.3.2 (2019-11-26) - Changelog","doc":"* Fix `Thumbnex.Animations.duration/1` regression.\n\n#","ref":"changelog.html#0-3-2-2019-11-26"},{"type":"extras","title":"0.3.1 (2019-09-05) - Changelog","doc":"* Bump ffmpex dependency to 0.7.0.\n* Bump mogrify dependency to 0.7.3.","ref":"changelog.html#0-3-1-2019-09-05"},{"type":"extras","title":"0.3.0 (2018-03-26) - Changelog","doc":"* Bump ffmpex dependency to 0.5.0.\n* Require Elixir 1.4.\n\n#","ref":"changelog.html#0-3-0-2018-03-26"},{"type":"extras","title":"0.2.4 (2017-07-27) - Changelog","doc":"* Fix Elixir 1.5, Erlang 19 warnings.\n\n#","ref":"changelog.html#0-2-4-2017-07-27"},{"type":"extras","title":"0.2.3 (2017-01-07) - Changelog","doc":"* Fix Elixir 1.4 warnings.\n* Bump mogrify dependency to 0.5.3.\n\n#","ref":"changelog.html#0-2-3-2017-01-07"},{"type":"extras","title":"0.2.2 (2016-12-03) - Changelog","doc":"* Bump ffmpex dependency to 0.4.0.\n\n#","ref":"changelog.html#0-2-2-2016-12-03"},{"type":"extras","title":"0.2.1 (2016-09-10) - Changelog","doc":"* Bump ffmpex dependency to 0.3.0.","ref":"changelog.html#0-2-1-2016-09-10"},{"type":"extras","title":"0.2.0 (2016-08-24) - Changelog","doc":"* Added `Thumbnex.animated_gif_thumbnail/3`.","ref":"changelog.html#0-2-0-2016-08-24"},{"type":"extras","title":"0.1.0 (2016-08-17) - Changelog","doc":"* First Thumbnex release.\n* Create thumbnail from image or video.\n* Specify dimensions, image format, and timestamp.","ref":"changelog.html#0-1-0-2016-08-17"},{"type":"extras","title":"MIT License","doc":"# MIT License\n\nCopyright (c) 2016 Andrew Shu\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"},{"type":"extras","title":"Thumbnex","doc":"# Thumbnex\n\n[![Build Status](https://github.com/talklittle/thumbnex/actions/workflows/ci.yml/badge.svg)](https://github.com/talklittle/thumbnex/actions?query=workflow%3ACI)\n[![Module Version](https://img.shields.io/hexpm/v/thumbnex.svg)](https://hex.pm/packages/thumbnex)\n\nElixir library to generate thumbnails from images and videos.\n\nDocumentation: https://hexdocs.pm/thumbnex/","ref":"readme.html"},{"type":"extras","title":"Installation - Thumbnex","doc":"Add `:thumbnex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:thumbnex, \"~> 0.5.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Prerequisites - Thumbnex","doc":"* [ImageMagick](https://imagemagick.org)\n* [FFmpeg](https://ffmpeg.org)","ref":"readme.html#prerequisites"},{"type":"extras","title":"Release notes - Thumbnex","doc":"See the [changelog](./CHANGELOG.md) for changes between versions.","ref":"readme.html#release-notes"},{"type":"extras","title":"Examples - Thumbnex","doc":"Create a regular thumbnail:\n\n```elixir\nThumbnex.create_thumbnail(\n  \"/path/to/input.mp4\",\n  \"/path/to/output.jpg\",\n  max_width: 200,\n  max_height: 200\n)\n```\n\nCreate a lightweight animated GIF preview:\n\n```elixir\nThumbnex.animated_gif_thumbnail(\n  \"/path/to/input.mp4\",\n  \"/path/to/output.gif\",\n  frame_count: 4,\n  fps: 1\n)\n```","ref":"readme.html#examples"},{"type":"extras","title":"Copyright and License - Thumbnex","doc":"Copyright (c) 2024 Andrew Shu\n\nThumbnex source code is licensed under the [MIT License](./LICENSE.md).","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown"}